diff --git a/src/main/java/net/minecraft/core/block/BlockChestLegacy.java b/src/main/java/net/minecraft/core/block/LegacyChestBlock.java
similarity index 79%
rename from src/main/java/net/minecraft/core/block/BlockChestLegacy.java
rename to src/main/java/net/minecraft/core/block/LegacyChestBlock.java
index 8b16e2890..ee4ad0fe7 100644
--- a/src/main/java/net/minecraft/core/block/BlockChestLegacy.java
+++ b/src/main/java/net/minecraft/core/block/LegacyChestBlock.java
@@ -1,11 +1,11 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.Global;
-import net.minecraft.core.block.BlockChest.Type;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityChest;
+import net.minecraft.core.block.ChestBlock.Type;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.ChestBlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
@@ -13,42 +13,42 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 @Deprecated
-public class BlockChestLegacy extends BlockTileEntity {
+public class LegacyChestBlock extends EntityBlock {
 	
-	public BlockChestLegacy(String key, int id, Material material) {
-		super(key, id, Material.wood);
+	public LegacyChestBlock(String key, String namespaceId, int id) {
+		super(key, namespaceId, id, Material.wood);
 	}
 	
 	@Override
-	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity) {
+	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity) {
 		if(isLegacyChest(world, x, y, z)) {
 			updateLegacyChest(world, x, y, z);
 		}
 		Block block = world.getBlock(x, y, z);
 		if(block != null) {
-			return super.getBreakResult(world, dropCause, x, y, z, meta, tileEntity);
+			return super.getBreakResult(world, dropCause, x, y, z, meta, blockEntity);
 		}
 		return null;
 	}
 
 	@Override
-	protected TileEntity getNewBlockEntity() {
-		return new TileEntityChest();
+	protected BlockEntity getNewBlockEntity() {
+		return new ChestBlockEntity();
 	}
 	
 	public static boolean isLegacyChest(World world, int x, int y, int z) {
 		int id = world.getBlockId(x, y, z);
-		return id == Block.chestLegacy.id || id == Block.chestLegacyPainted.id;
+		return id == Blocks.CHEST_LEGACY.id || id == Blocks.CHEST_LEGACY_PAINTED.id;
 	}
 	
 	@Override
 	public void onBlockRemoved(World world, int x, int y, int z, int data) {
-		BlockChest.dropChestContent(world, x, y, z);
+		ChestBlock.dropChestContent(world, x, y, z);
 		super.onBlockRemoved(world, x, y, z, data);
 	}
 	
 	@Override
-	public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
+	public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
 		if(world.isClientSide) {
 			return true;
 		}
@@ -92,8 +92,8 @@ public class BlockChestLegacy extends BlockTileEntity {
 				facingDirection = Direction.SOUTH;
 			}
 			
-			meta = BlockChest.getMetaWithDirection(meta, facingDirection);
-			meta = BlockChest.getMetaWithType(meta, Type.SINGLE);
+			meta = ChestBlock.getMetaWithDirection(meta, facingDirection);
+			meta = ChestBlock.getMetaWithType(meta, Type.SINGLE);
 			
 			ItemStack[] items = getAndClearChestInventory(world, x, y, z);
 			
@@ -155,11 +155,11 @@ public class BlockChestLegacy extends BlockTileEntity {
 			if(type == Type.LEFT) otherType = Type.RIGHT;
 			if(type == Type.RIGHT) otherType = Type.LEFT;
 			
-			meta = BlockChest.getMetaWithDirection(meta, facingDirection);
-			meta = BlockChest.getMetaWithType(meta, type);
+			meta = ChestBlock.getMetaWithDirection(meta, facingDirection);
+			meta = ChestBlock.getMetaWithType(meta, type);
 			
-			otherMeta = BlockChest.getMetaWithDirection(otherMeta, facingDirection);
-			otherMeta = BlockChest.getMetaWithType(otherMeta, otherType);
+			otherMeta = ChestBlock.getMetaWithDirection(otherMeta, facingDirection);
+			otherMeta = ChestBlock.getMetaWithType(otherMeta, otherType);
 			
 			ItemStack[] items1 = getAndClearChestInventory(world, x, y, z);
 			ItemStack[] items2 = getAndClearChestInventory(world, otherChestX, y, otherChestZ);
@@ -178,23 +178,23 @@ public class BlockChestLegacy extends BlockTileEntity {
 	}
 	
 	private ItemStack[] getAndClearChestInventory(World world, int x, int y, int z) {
-		TileEntityChest tileEntityChest = (TileEntityChest) world.getBlockTileEntity(x, y, z);
+		ChestBlockEntity tileEntityChest = (ChestBlockEntity) world.getBlockEntity(x, y, z);
 		
-		ItemStack[] items = new ItemStack[tileEntityChest.getSizeInventory()];
+		ItemStack[] items = new ItemStack[tileEntityChest.getContainerSize()];
 		
 		for(int i=0; i < items.length; i++) {
-			items[i] = tileEntityChest.getStackInSlot(i);
-			tileEntityChest.setInventorySlotContents(i, null);
+			items[i] = tileEntityChest.getItem(i);
+			tileEntityChest.setItem(i, null);
 		}
 		
 		return items;
 	}
 	
 	private void setChestInventory(World world, int x, int y, int z, ItemStack[] items) {
-		TileEntityChest tileEntityChest = (TileEntityChest) world.getBlockTileEntity(x, y, z);
+		ChestBlockEntity tileEntityChest = (ChestBlockEntity) world.getBlockEntity(x, y, z);
 		
 		for(int i=0; i < items.length; i++) {
-			tileEntityChest.setInventorySlotContents(i, items[i]);
+			tileEntityChest.setItem(i, items[i]);
 		}
 	}
 	
@@ -207,10 +207,10 @@ public class BlockChestLegacy extends BlockTileEntity {
 		int legacyChestMeta = world.getBlockMetadata(x, y, z);
 		
 		Block oldBlock = world.getBlock(x, y, z);
-		Block newBlock = Block.chestPlanksOak;
+		Block newBlock = Blocks.CHEST_PLANKS_OAK;
 		
-		if(oldBlock == Block.chestLegacyPainted) {
-			newBlock = Block.chestPlanksOakPainted;
+		if(oldBlock == Blocks.CHEST_LEGACY_PAINTED) {
+			newBlock = Blocks.CHEST_PLANKS_OAK_PAINTED;
 			newMeta = newMeta | (legacyChestMeta << 4);
 		}
 		
diff --git a/src/main/java/net/minecraft/core/block/LeverBlock.java b/src/main/java/net/minecraft/core/block/LeverBlock.java
new file mode 100644
index 000000000..21af5a45b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/LeverBlock.java
@@ -0,0 +1,302 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.tag.ItemTags;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.World;
+
+public class LeverBlock extends Block
+{
+    public static final int MASK_POWERED = 0b0001_0000;
+    public static final int MASK_ROTATION = 0b0000_1111;
+    public static final int ROTATION_EAST = 1;
+    public static final int ROTATION_WEST = 2;
+    public static final int ROTATION_SOUTH = 3;
+    public static final int ROTATION_NORTH = 4;
+    public static final int ROTATION_TOP_NS = 5;
+    public static final int ROTATION_TOP_WE = 6;
+    public static final int ROTATION_BOTTOM_NS = 7;
+    public static final int ROTATION_BOTTOM_WE = 8;
+
+	public LeverBlock(String key, String namespaceId, int id)
+    {
+        super(key, namespaceId, id, Material.decoration);
+    }
+
+    @Override
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
+    {
+        return null;
+    }
+
+    @Override
+	public boolean isSolidRender()
+    {
+        return false;
+    }
+
+    @Override
+	public boolean isCubeShaped()
+    {
+        return false;
+    }
+
+    @Override
+    public boolean canPlaceBlockOnSide(World world, int x, int y, int z, Side side) {
+        Side checkSide = side.getOpposite();
+        return world.isBlockNormalCube(x + checkSide.getOffsetX(), y + checkSide.getOffsetY(), z + checkSide.getOffsetZ());
+    }
+
+
+    @Override
+	public boolean canPlaceBlockAt(World world, int x, int y, int z)
+    {
+        for (Side s : Side.sides){
+            if(world.isBlockNormalCube(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ())){
+                return true;
+            }
+        }
+        return false;
+    }
+    
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+        int meta = world.getBlockMetadata(x, y, z);
+        boolean isPowered = isPowered(meta);
+        int rotation = -1;
+        switch (side){
+            case BOTTOM:
+                if (world.canPlaceOnSurfaceOfBlock(x, y + 1, z)){
+                    rotation = ROTATION_BOTTOM_NS + (mob.getHorizontalPlacementDirection(side).getAxis() == Axis.Z ? 1 : 0);
+                }
+                break;
+            case TOP:
+                if (world.canPlaceOnSurfaceOfBlock(x, y - 1, z))
+                {
+                    rotation = ROTATION_TOP_NS + (mob.getHorizontalPlacementDirection(side).getAxis() == Axis.Z ? 1 : 0);
+                }
+                break;
+            case NORTH:
+                if (world.isBlockNormalCube(x, y, z + 1)){
+                    rotation = ROTATION_NORTH;
+                }
+                break;
+            case SOUTH:
+                if (world.isBlockNormalCube(x, y, z - 1)){
+                    rotation = ROTATION_SOUTH;
+                }
+                break;
+            case WEST:
+                if (world.isBlockNormalCube(x + 1, y, z)){
+                    rotation = ROTATION_WEST;
+                }
+                break;
+            case EAST:
+                if (world.isBlockNormalCube(x - 1, y, z)){
+                    rotation = ROTATION_EAST;
+                }
+                break;
+        }
+
+        if(rotation == -1) {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            world.setBlockWithNotify(x, y, z, 0);
+        } else {
+            world.setBlockMetadataWithNotify(x, y, z, rotation | (isPowered ? MASK_POWERED : 0));
+        }
+    }
+    
+    @Override
+	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
+    {
+        if(checkIfAttachedToBlock(world, x, y, z))
+        {
+            int rotation = getRotation(world.getBlockMetadata(x, y, z));
+            boolean shouldBreak;
+            switch (rotation){
+                case ROTATION_EAST:
+                    shouldBreak = !world.isBlockNormalCube(x - 1, y, z);
+                    break;
+                case ROTATION_WEST:
+                    shouldBreak = !world.isBlockNormalCube(x + 1, y, z);
+                    break;
+                case ROTATION_SOUTH:
+                    shouldBreak = !world.isBlockNormalCube(x, y, z - 1);
+                    break;
+                case ROTATION_NORTH:
+                    shouldBreak = !world.isBlockNormalCube(x, y, z + 1);
+                    break;
+                case ROTATION_TOP_NS:
+                case ROTATION_TOP_WE:
+                    shouldBreak = !world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+                    break;
+                case ROTATION_BOTTOM_NS:
+                case ROTATION_BOTTOM_WE:
+                    shouldBreak = !world.canPlaceOnSurfaceOfBlock(x, y + 1, z);
+                    break;
+                default:
+                    shouldBreak = true;
+            }
+            if(shouldBreak)
+            {
+                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+                world.setBlockWithNotify(x, y, z, 0);
+            }
+        }
+    }
+
+    private boolean checkIfAttachedToBlock(World world, int x, int y, int z)
+    {
+        if(!canPlaceBlockAt(world, x, y, z))
+        {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            world.setBlockWithNotify(x, y, z, 0);
+            return false;
+        } else
+        {
+            return true;
+        }
+    }
+
+    @Override
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    {
+        int rotation = getRotation(world.getBlockMetadata(x, y, z));
+        float f = 0.1875F;
+        if(rotation == ROTATION_EAST) {
+            setBlockBounds(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
+        } else if(rotation == ROTATION_WEST) {
+            setBlockBounds(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
+        } else if(rotation == ROTATION_SOUTH) {
+            setBlockBounds(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
+        } else if(rotation == ROTATION_NORTH) {
+            setBlockBounds(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
+        } else if (rotation == ROTATION_TOP_NS || rotation == ROTATION_TOP_WE) {
+            float f1 = 0.25F;
+            setBlockBounds(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
+        } else {
+            float f1 = 0.25F;
+            setBlockBounds(0.5F - f1, 0.4, 0.5F - f1, 0.5F + f1, 1F, 0.5F + f1);
+        }
+    }
+
+    @Override
+    public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
+    {
+    	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
+    		onBlockRightClicked(world, x, y, z, player, null, 0.0, 0.0);
+    	}
+    }
+
+    @Override
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
+    {
+        int meta = world.getBlockMetadata(x, y, z);
+        int rotation = getRotation(meta);
+        if (isPowered(meta)){
+            world.setBlockMetadataWithNotify(x, y, z, meta & ~MASK_POWERED);
+        } else {
+            world.setBlockMetadataWithNotify(x, y, z, meta | MASK_POWERED);
+        }
+
+        world.markBlocksDirty(x, y, z, x, y, z);
+        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.click", 0.3F, isPowered(meta) ? 0.5F : 0.6F);
+        world.notifyBlocksOfNeighborChange(x, y, z, id);
+        if(rotation == ROTATION_EAST) {
+            world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
+        } else if(rotation == ROTATION_WEST) {
+            world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
+        } else if(rotation == ROTATION_SOUTH) {
+            world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
+        } else if(rotation == ROTATION_NORTH) {
+            world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+        } else if (rotation == ROTATION_TOP_NS || rotation == ROTATION_TOP_WE){
+            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+        } else {
+            world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+        }
+        return true;
+    }
+
+    @Override
+    public void onBlockRemoved(World world, int x, int y, int z, int data)
+    {
+        if(isPowered(data))
+        {
+            world.notifyBlocksOfNeighborChange(x, y, z, id);
+            int rotation = getRotation(data);
+            if(rotation == ROTATION_EAST) {
+                world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
+            } else if(rotation == ROTATION_WEST) {
+                world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
+            } else if(rotation == ROTATION_SOUTH) {
+                world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
+            } else if(rotation == ROTATION_NORTH) {
+                world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+            } else if (rotation == ROTATION_TOP_NS || rotation == ROTATION_TOP_WE){
+                world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            } else {
+                world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+            }
+        }
+        super.onBlockRemoved(world, x, y, z, data);
+    }
+    public static int getRotation(int meta){
+        return meta & MASK_ROTATION;
+    }
+
+    @Override
+    public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side)
+    {
+        return isPowered(worldSource.getBlockMetadata(x, y, z));
+    }
+    public static boolean isPowered(int meta){
+        return (meta & MASK_POWERED) != 0;
+    }
+
+    @Override
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side)
+    {
+        int meta = world.getBlockMetadata(x, y, z);
+        if(!isPowered(meta)) {
+            return false;
+        }
+        int rotation = getRotation(meta);
+        if(rotation == ROTATION_BOTTOM_WE && side == Side.BOTTOM) {
+            return true;
+        }
+        if(rotation == ROTATION_BOTTOM_NS && side == Side.BOTTOM) {
+            return true;
+        }
+        if(rotation == ROTATION_TOP_WE && side == Side.TOP) {
+            return true;
+        }
+        if(rotation == ROTATION_TOP_NS && side == Side.TOP) {
+            return true;
+        }
+        if(rotation == ROTATION_NORTH && side == Side.NORTH) {
+            return true;
+        }
+        if(rotation == ROTATION_SOUTH && side == Side.SOUTH) {
+            return true;
+        }
+        if(rotation == ROTATION_WEST && side == Side.WEST) {
+            return true;
+        }
+        return rotation == ROTATION_EAST && side == Side.EAST;
+    }
+
+    @Override
+    public boolean isSignalSource()
+    {
+        return true;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockLog.java b/src/main/java/net/minecraft/core/block/LogBlock.java
similarity index 82%
rename from src/main/java/net/minecraft/core/block/BlockLog.java
rename to src/main/java/net/minecraft/core/block/LogBlock.java
index 0a9a7caa8..b015d03b2 100644
--- a/src/main/java/net/minecraft/core/block/BlockLog.java
+++ b/src/main/java/net/minecraft/core/block/LogBlock.java
@@ -3,12 +3,12 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
-public class BlockLog extends BlockAxisAligned
+public class LogBlock extends AxisAlignedBlock
 {
 
-	public BlockLog(String key, int id)
+	public LogBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.wood);
+        super(key, namespaceId, id, Material.wood);
     }
 
     @Override
@@ -25,7 +25,7 @@ public class BlockLog extends BlockAxisAligned
                     for(int k1 = -byte0; k1 <= byte0; k1++)
                     {
                         int l1 = world.getBlockId(x + i1, y + j1, z + k1);
-                        if(!(Block.blocksList[l1] instanceof BlockLeavesBase))
+                        if(!(Block.blocksList[l1] instanceof BaseLeavesBlock))
                         {
                             continue;
                         }
diff --git a/src/main/java/net/minecraft/core/block/BlockMesh.java b/src/main/java/net/minecraft/core/block/MeshBlock.java
similarity index 64%
rename from src/main/java/net/minecraft/core/block/BlockMesh.java
rename to src/main/java/net/minecraft/core/block/MeshBlock.java
index 03307b030..b7b0cf44c 100644
--- a/src/main/java/net/minecraft/core/block/BlockMesh.java
+++ b/src/main/java/net/minecraft/core/block/MeshBlock.java
@@ -5,19 +5,19 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.world.World;
 
-public class BlockMesh extends BlockTransparent
+public class MeshBlock extends TransparentBlock
 {
 
-    public BlockMesh(String key, int id)
+    public MeshBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.metal);
+        super(key, namespaceId, id, Material.metal);
     }
     
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
@@ -30,6 +30,6 @@ public class BlockMesh extends BlockTransparent
 
     @Override
     public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
-        return !(entity instanceof EntityItem);
+        return !(entity instanceof ItemEntity);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockMobSpawner.java b/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
similarity index 68%
rename from src/main/java/net/minecraft/core/block/BlockMobSpawner.java
rename to src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
index 8091527ec..e2e09f731 100644
--- a/src/main/java/net/minecraft/core/block/BlockMobSpawner.java
+++ b/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
@@ -1,29 +1,29 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityMobSpawner;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class BlockMobSpawner extends BlockTileEntity
+public class MobSpawnerBlock extends EntityBlock
 {
 
-	public BlockMobSpawner(String key, int id)
+	public MobSpawnerBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.stone);
+        super(key, namespaceId, id, Material.stone);
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
         if (player.getGamemode() != Gamemode.creative) {
             return false;
         }
@@ -33,26 +33,26 @@ public class BlockMobSpawner extends BlockTileEntity
     }
 
     @Override
-	public TileEntity getNewBlockEntity()
+	public BlockEntity getNewBlockEntity()
     {
-        return new TileEntityMobSpawner();
+        return new MobSpawnerBlockEntity();
     }
 
     @Override
-	public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
-    	TileEntityMobSpawner tileEntity = (TileEntityMobSpawner) world.getBlockTileEntity(x, y, z);
+	public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    	MobSpawnerBlockEntity tileEntity = (MobSpawnerBlockEntity) world.getBlockEntity(x, y, z);
     	tileEntity.setMobId("none");
     }
 
     @Override
     public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
-        return !(entity instanceof EntityItem);
+        return !(entity instanceof ItemEntity);
     }
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
         if (!world.isClientSide) {
-            TileEntityMobSpawner tileEntityMobSpawner = (TileEntityMobSpawner) world.getBlockTileEntity(x, y, z);
+            MobSpawnerBlockEntity tileEntityMobSpawner = (MobSpawnerBlockEntity) world.getBlockEntity(x, y, z);
             if (tileEntityMobSpawner == null) return;
             int amountToDrop = world.rand.nextInt(10) + 10;
             label0:
@@ -62,22 +62,22 @@ public class BlockMobSpawner extends BlockTileEntity
                     ItemStack itemstack;
                     switch (mobInSpawner) {
                         case "Zombie":
-                            itemstack = new ItemStack(Item.cloth);
+                            itemstack = new ItemStack(Items.CLOTH);
                             break;
                         case "Skeleton":
                             if (world.rand.nextInt(2) == 0)
-                                itemstack = new ItemStack(Item.bone);
+                                itemstack = new ItemStack(Items.BONE);
                             else
-                                itemstack = new ItemStack(Item.ammoArrow);
+                                itemstack = new ItemStack(Items.AMMO_ARROW);
                             break;
                         case "ArmouredZombie":
-                            itemstack = new ItemStack(Item.chainlink);
+                            itemstack = new ItemStack(Items.CHAINLINK);
                             break;
                         case "Spider":
-                            itemstack = new ItemStack(Item.string);
+                            itemstack = new ItemStack(Items.STRING);
                             break;
                         case "Snowman":
-                            itemstack = new ItemStack(Item.ammoSnowball);
+                            itemstack = new ItemStack(Items.AMMO_SNOWBALL);
                             break;
                         default:
                             itemstack = null;
@@ -99,7 +99,7 @@ public class BlockMobSpawner extends BlockTileEntity
                             i1 = itemstack.stackSize;
                         }
                         itemstack.stackSize -= i1;
-                        EntityItem entityitem = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                        ItemEntity entityitem = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
                         float f3 = 0.05F;
                         entityitem.xd = (float) world.rand.nextGaussian() * f3;
                         entityitem.yd = (float) world.rand.nextGaussian() * f3 + 0.2F;
@@ -113,11 +113,11 @@ public class BlockMobSpawner extends BlockTileEntity
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         if (dropCause == EnumDropCause.SILK_TOUCH)
         {
-            return new ItemStack[] { new ItemStack(Block.mobspawnerDeactivated) };
+            return new ItemStack[] { new ItemStack(Blocks.MOBSPAWNER_DEACTIVATED) };
         }
         return null;
     }
@@ -129,7 +129,7 @@ public class BlockMobSpawner extends BlockTileEntity
     }
     
     @Override
-	public boolean renderAsNormalBlock() {
+	public boolean isCubeShaped() {
     	return false;
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockMobSpawnerDeactivated.java b/src/main/java/net/minecraft/core/block/MobSpawnerDeactivatedBlock.java
similarity index 64%
rename from src/main/java/net/minecraft/core/block/BlockMobSpawnerDeactivated.java
rename to src/main/java/net/minecraft/core/block/MobSpawnerDeactivatedBlock.java
index c940c70c5..d41842fbb 100644
--- a/src/main/java/net/minecraft/core/block/BlockMobSpawnerDeactivated.java
+++ b/src/main/java/net/minecraft/core/block/MobSpawnerDeactivatedBlock.java
@@ -1,21 +1,21 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class BlockMobSpawnerDeactivated extends BlockTransparent{
-    public BlockMobSpawnerDeactivated(String key, int id, Material material)
+public class MobSpawnerDeactivatedBlock extends TransparentBlock {
+    public MobSpawnerDeactivatedBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
     }
 
     @Override
-    public boolean renderAsNormalBlock()
+    public boolean isCubeShaped()
     {
         return false;
     }
@@ -28,10 +28,10 @@ public class BlockMobSpawnerDeactivated extends BlockTransparent{
 
     @Override
     public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
-        return !(entity instanceof EntityItem);
+        return !(entity instanceof ItemEntity);
     }
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
